import os, time
import sys
import json
from ..postprocess import post as P
import PySimpleGUI as sg
# from pkg_resources import resource_stream# 还有resource_stream


TOP_LEVEL = os.path.abspath(os.path.dirname(os.path.dirname(__file__)))

CONFIG_PATH = os.path.join(TOP_LEVEL, "config.json")

# ICON_PATH = os.path.join(sys.prefix, "share", "hexotools", "hexotools.ico")
# ICON_PATH = resource_stream(__name__, '../hexotools.icon')
ICON_PATH = os.path.join(TOP_LEVEL, "static", "hexotools.ico")

with open(CONFIG_PATH, "r", encoding='utf-8') as fo:
    CONFIG = json.load(fo)


def urlFormat(url, delete_url="", description="", path=""):
    s = (
        "###--Markdown--###\n", '![{0}]({1})'.format(description, url), "\n\n",
        "###-----URL----###\n", "%s" % url, "\n\n", "###----HTML----###\n",
        '<a href="%s" target="_blank"><img src="https://i.loli.net/2019/10/03/TBgyP2nEcFar8Vw.png" ></a>'
        % url, "\n\n")
    if delete_url:
        s += ("###---删除URL---###\n", "%s" % delete_url, "\n\n")

    if path:
        s += ("###---本地路径---###\n", "%s" % path)
    return "".join(s)


def editCate(folder=CONFIG["posts_path"], root=CONFIG["posts_path"]):
    edit_cate = P.EditCate()
    for i in edit_cate.getMDFlie(folder):
        edit_cate.writeToFile(i, edit_cate.getWriteContent(i, root))


if __name__ == "__main__":
    r = urlFormat("http://www.baidu.com", delete_url="DD", description="tu")
    print(r)


def setConf(item=None, value=None, *values, **vk):
    if vk:
        for v, k in vk.items():
            CONFIG[v] = k
    elif values:
        CONFIG[item] = values
    else:
        CONFIG[item] = value
    with open(CONFIG_PATH, "w") as fo:
        json.dump(CONFIG, fo, sort_keys=True, indent=4)

def getConf(item):
    return CONFIG.get(item, None)


def setPath(path):
    if os.path.isdir(path):
        CONFIG["blog_path"] = os.path.normpath(path)
        CONFIG["disk"] = CONFIG["blog_path"].split(os.path.sep)[0]
        CONFIG["posts_path"] = os.path.join(
            CONFIG["blog_path"], "source{}_posts".format(os.path.sep))
        CONFIG["db"] = os.path.join(CONFIG["blog_path"], "img.db")
        CONFIG["pop_introduction"] = False
        with open(CONFIG_PATH, "w") as fo:
            json.dump(CONFIG, fo, sort_keys=True, indent=4)

def confUi():
    in_style = {'size': (25, 1)}
    t_style = {"size": (10, 1)}
    layout = [[
        sg.T("Blog文件夹", auto_size_text=False, justification='right',
             **t_style),
        sg.In(CONFIG.get("blog_path", "例 D:/blog"),
              key="_blog_path_",
              **in_style),
        sg.FolderBrowse("浏览")
    ],
              [
                  sg.T("文章文件夹",
                       auto_size_text=False,
                       justification='right',
                       **t_style),
                  sg.In(CONFIG.get("posts_path", "例 D:/blog/source/_posts"),
                        key="_posts_path_",
                        **in_style),
                  sg.FolderBrowse("浏览")
              ],
              [
                  sg.T("Sqlite数据库",
                       auto_size_text=False,
                       justification="right",
                       **t_style),
                  sg.In(CONFIG.get("db", "例 D:/blog/img.db"),
                        key="_db_",
                        **in_style),
                  sg.FileBrowse(
                      "浏览",
                      file_types=[('Sqlite数据库', '*.db')],
                  )
              ], [sg.B("确定")]]
    win = sg.Window("设置", layout, icon=ICON_PATH)
    while True:
        event, values = win.Read()
        if event == "确定":
            vk = {
                "blog_path": os.path.normpath(values["_blog_path_"]),
                "posts_path": os.path.normpath(values["_posts_path_"]),
                "db": os.path.normpath(values["_db_"])
            }
            setConf(**vk)
            sg.PopupAutoClose("成功", icon=ICON_PATH)
            break
        elif event is None:
            break
    win.close()


def initConf():
    layout = [[
        sg.InputText('博客文件夹',
                     tooltip="source文件夹所在的文件夹, 不包括source",
                     key="_blog_path_",
                     size=(25, 1)),
        sg.FolderBrowse("浏览", tooltip="选择路径"),
        sg.Button('确定')
    ]]
    win = sg.Window("初始化设置", layout=layout, icon=ICON_PATH)
    event, values = win.read()

    if event == "确定" and os.path.exists(values["_blog_path_"]):
        setPath(values['_blog_path_'])
        sg.PopupAutoClose("成功",icon=ICON_PATH, auto_close_duration=1)
        win.close()
        return True
    else:
        win.close()
        return False

def newPostUi():
    layout = [
        [sg.T("标题"), sg.In("", key="_title_")],
        [sg.T("分类"), sg.In("未分类", key="_cate_")],
        [sg.T("标签"), sg.In("", key="_tags_")],
        [sg.B("确定")]
    ]
    win = sg.Window("创建文章", layout, icon=ICON_PATH)
    event, values = win.read()
    if event == "确定":
        post = P.NewPost(values["_title_"], 
        values["_cate_"].split("/"), 
        values['_tags_'].split("/"),
        date = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()))
        post.newPost(getConf("posts_path"))
    win.close()